con

                                                    
                                                                                       
                                                                                   
  ioreadcmd   = %00000001                                                                      
  iowritecmd  = %00000010                                                                       
  ioread1cmd  = %00000011                                                                    
  iowrite1cmd = %00000100                                                                   
  ioread0cmd  = %00000101                                                                
  iowrite0cmd = %00000110                                                               
  iobootcmd   = %00001000                                                                 
                                                                                             
                                                                                              
                                                                                             
                                                                                                
  iospiinit   = %00010000                                                                    
  iospistop   = %00010001                                                         
  iospiread   = %00010010                                                               
  iospiwrite  = %00010011                                                                
  iospiboot   = %00011000                                                                      
  iocmdmask   = %00011111                                                     
  iospimask   = %00010000                                                          
                      
  ionostore   = %00100000                                                                   
                                                                                        
                                                                                        
  iolowspeed  = %01000000                                                                     
  iostopldr   = %10000000                                                                        
               
  iowriteerr  = %10000000                                                                   
  iotestrdy   = iocmdmask << 24                                                         
  iotesterr   = iowriteerr << 24                                                              
                                 
  i2cbootscl  = 28                                                  
  bootaddr    = i2cbootscl << 18                                       
  clkfreqval  = $0000                                                             
  clksetval   = $0004                                                            
  chksumval   = $0005                                                            
  vbase       = $0008                                                                       
  dbase       = $000a                                                                    

var

  long cog, control

pub computetimes                                                                             

                                                                                           
  i2cdataset1 := ((clkfreq / 10000) *  900) / 100000                                      
  i2cclklow1  := ((clkfreq / 10000) * 4700) / 100000                                      
  i2cclkhigh1 := ((clkfreq / 10000) * 4000) / 100000                                      
  i2cdataset4 := ((clkfreq / 10000) *  550) / 100000                                      
  i2cclklow4  := ((clkfreq / 10000) * 1300) / 100000                                      
  i2cclkhigh4 := ((clkfreq / 10000) * 1000) / 100000                                      
  i2cpause    := clkfreq / 100000                                                           

pub initsdcard(do,clk,di,cs) | t                                                   

  t := cnt
  repeat while long[control][0] & iotestrdy                                             
  long[control][1] := 0
  long[control][0] := iospiinit << 24 | do << 18 | clk << 12 | di << 6 | cs
  repeat while long[control][0] & iotestrdy                                     
  return (long[control][0] & iotesterr) <> 0                                  

pub stopsdcard                                                               

  repeat while long[control][0] & iotestrdy                                             
  long[control][1] := 0
  long[control][0] := iospistop << 24
  repeat while long[control][0] & iotestrdy                                     
  return (long[control][0] & iotesterr) <> 0                                  

pub readsdcard(addr,buffer,count)                                                          

  repeat while long[control][0] & iotestrdy                                             
  long[control][1] := (count << 16) | (buffer & $ffff)
  long[control][0] := (iospiread << 24) | (addr & $ffffff)
  repeat while long[control][0] & iotestrdy                                     
  return (long[control][0] & iotesterr) <> 0                                  

pub writesdcard(addr,buffer,count)                                                          

  repeat while long[control][0] & iotestrdy                                             
  long[control][1] := (count << 16) | (buffer & $ffff)
  long[control][0] := (iospiwrite << 24) | (addr & $ffffff)
  repeat while long[control][0] & iotestrdy                                     
  return (long[control][0] & iotesterr) <> 0                                  

pub bootsdcard(addr,count) | t                                                

  if count < 16                                                                     
    return true
  repeat t from 0 to 7                                                                    
    if (t <> cogid) and (t <> (cog-1))                                                   
        cogstop(t)
  t := iospiboot | iostopldr | cogid                                                    
  long[control][1] := count << 16                                                    
  long[control][0] := (t << 24) | (addr & $ffffff)                         
  repeat while long[control][0] & iotestrdy                                     
  return (long[control][0] & iotesterr) <> 0                                  

pub start(ctrlblk) | t                                                                         

  control := ctrlblk                                                                           
  stop                                                                       
  computetimes
  long[control][0] := 0                                                              
  long[control][1] := 0
  cog := cognew(@i2centrypoint,control) + 1                                                 
  return cog > 0                                                         

pub stop                                                                                      

  if cog > 0
    cogstop(cog - 1)

dat

                        org     0
i2centrypoint           mov     i2ctemp,i2cpause
                        add     i2ctemp,cnt                                        
                        waitcnt i2ctemp,#0
i2cnewopfetch           rdlong  i2caddr,par                                        
                        mov     i2ccmd,i2caddr
                        shr     i2ccmd,#24                                    
                        mov     options,i2ccmd
                        and     i2caddr,i2caddrmask                                      
                        and     i2ccmd,#iocmdmask  wz
                if_z    jmp     #i2centrypoint                                    
                        mov     i2ctemp,par
                        add     i2ctemp,#4                                          
                        rdlong  i2ccount,i2ctemp
                        mov     i2cbufadr,i2ccount                  
                        rdlong  saveclkfreq,#clkfreqval                                
                        shr     i2ccount,#16
                        and     i2cbufadr,i2cwordmask                              
                        rdbyte  saveclkmode,#clksetval
                        movs    shiftdata,#0                                            
                        mov     storelocal,initstore                           
                        mov     preamble+0,#0
                        mov     preamble+1,#0
                        mov     preamble+2,#0
                        mov     preamble+3,#0
                        mov     checksum,#$ec                                             
                        test    options,#ionostore wc
                        test    i2ccmd,#iobootcmd  wz
         if_nz_and_nc   mov     i2ctemp,i2ccmd                                        
         if_nz_and_nc   and     i2ctemp,#%111                           
         if_nz_and_nc   cogid   i2ccogid
         if_nz_and_nc   cmp     i2ccogid,i2ctemp   wz
         if_nz_and_nc   cogstop i2ctemp
                        test    i2ccmd,#iospimask  wz                           
                if_nz   jmp     #spientrypoint
                        movs    :getaction,i2ccmd                                    
                        test    i2ccmd,#iobootcmd  wz                                 
                if_nz   movs    :getaction,#ioreadcmd                                
                        add     :getaction,#actiontbl
                        mov     i2cdataset,i2cdataset1
                        mov     i2cclklow,i2cclklow1
                        mov     i2cclkhigh,i2cclkhigh1
:getaction              mov     action,0-0
                        test    options,#iolowspeed wc                                 
                if_nc   mov     i2cdataset,i2cdataset4
                if_nc   mov     i2cclklow,i2cclklow4
                if_nc   mov     i2cclkhigh,i2cclkhigh4
                        mov     i2ctemp,i2caddr
                        shr     i2ctemp,#18                                      
                        and     i2ctemp,#%11110                                
                        mov     i2cscl,#1
                        shl     i2cscl,i2ctemp
                        mov     i2csda,i2cscl                                   
                        shl     i2csda,#1
                        test    firstcall,i2cscl   wz                            
                        andn    firstcall,i2cscl                            
                if_nz   call    #i2creset
                        call    #i2cstart                                    
                        test    action,#%000000001 wz
                if_z    jmp     #:skipaction0
                        mov     i2cdata,i2caddr                                    
                        shr     i2cdata,#15                                          
                        and     i2cdata,#%00001110                              
                        or      i2cdata,#%10100000
                        mov     i2cmask,#%10000000
                        call    #i2cwrite                                        
                if_c    jmp     #:dostop                                         
:skipaction0            test    action,#%000000010 wz
                if_z    jmp     #:skipaction1
                        mov     i2cdata,i2caddr                                     
                        shr     i2cdata,#8                                            
                        mov     i2cmask,#%10000000
                        call    #i2cwrite                                        
                if_c    jmp     #:dostop                                         
:skipaction1            test    action,#%000000100 wz
                if_z    jmp     #:skipaction2
                        mov     i2cdata,i2caddr                                       
                        mov     i2cmask,#%10000000                                    
                        call    #i2cwrite                                         
                if_c    jmp     #:dostop                                         
:skipaction2            tjz     i2ccount,#:dostop                                       
                        test    action,#%000001000 wz
                if_nz   call    #i2cstart                                                    
:doreadwrite            test    action,#%000010000 wz
                if_nz   rdbyte  i2cdata,i2cbufadr                                         
                if_nz   add     i2cbufadr,#1                                            
                        test    action,#%000100000 wz
                if_z    jmp     #:skipaction5
                        mov     i2cdata,i2caddr                                                
                        shr     i2cdata,#15                                              
                        and     i2cdata,#%00001110                         
                        or      i2cdata,#%10100001
:skipaction5            test    action,#%001000000 wz
                if_z    jmp     #:skipaction6
                        mov     i2cdata,i2caddr                                                 
                        shr     i2cdata,#8                                                   
                        or      i2cdata,#%00000001                                            
:skipaction6            test    action,#%010000000 wz
                if_z    jmp     #:skipaction7
                        mov     i2cmask,#%10000000                                           
                        call    #i2cwrite                                                     
                if_c    jmp     #:dostop                                         
:skipaction7            test    action,#%100000000 wz
                if_z    jmp     #:skipaction8
                        cmp     i2ccount,#2        wc                                        
                        mov     i2cmask,#%10000000
                        mov     i2cdata,#0
                        call    #i2cread
                        call    #storedata                                                     
                        or      i2czero,#0      nr,wc
                        andn    action,#%011100000                                           
:skipaction8            add     i2caddr,#1
                        djnz    i2ccount,#:doreadwrite                                        
:dostop                 call    #i2cstop
                if_c    or      i2caddr,errorflag                                   
                        jmp     #checkendio
                                                                                     
                                                                                     
                                                                 
                                                                             
                                                                           
i2creset                andn    dira,i2csda                                    
                        mov     i2cbitcnt,#9                                    
                        mov     i2ctime,i2cclklow
                        add     i2ctime,cnt                                        
:i2cresetclk            andn    outa,i2cscl                                   
                        or      dira,i2cscl            
                        waitcnt i2ctime,i2cclkhigh
                        test    i2cbootsclm,i2cscl wz                           
              if_nz     or      outa,i2cscl                                    
              if_nz     or      dira,i2cscl
              if_z      andn    dira,i2cscl                                    
                        waitcnt i2ctime,i2cclklow                               
                        test    i2csda,ina         wz                        
              if_z      djnz    i2cbitcnt,#:i2cresetclk                      
i2creset_ret            ret                                                              
                                                                        
                                                                         
                                                                           
i2cstart                andn    dira,i2csda                                    
                        andn    outa,i2csda                                   
                        mov     i2ctime,i2cclklow
                        add     i2ctime,cnt                                      
                        waitcnt i2ctime,i2cclkhigh
                        test    i2cbootsclm,i2cscl wz                           
              if_nz     or      outa,i2cscl                                    
              if_nz     or      dira,i2cscl
              if_z      andn    dira,i2cscl                                    
                        waitcnt i2ctime,i2cclkhigh                                  
                        or      dira,i2csda                                   
                        waitcnt i2ctime,#0                                         
                        andn    outa,i2cscl                                   
                        or      dira,i2cscl
i2cstart_ret            ret                             
                                                                                
                                                                          
                                                                                   
                                                                            
i2cstop                 or      dira,i2csda                                   
                        mov     i2ctime,i2cclklow
                        add     i2ctime,cnt                                         
                        waitcnt i2ctime,i2cclklow
                        test    i2cbootsclm,i2cscl wz                           
              if_nz     or      outa,i2cscl                                    
              if_nz     or      dira,i2cscl
              if_z      andn    dira,i2cscl                                    
                        waitcnt i2ctime,i2cclkhigh                                   
                        andn    dira,i2csda                                    
                        waitcnt i2ctime,#0                                       
                        andn    dira,i2cscl                                     
i2cstop_ret             ret
                                                                                   
                                                                                        
                                                                                       
                                                                    
i2cwrite                mov     i2cbitcnt,#8
                        mov     i2ctime,i2cclklow
                        add     i2ctime,cnt                                       
:i2cwritebit            waitcnt i2ctime,i2cdataset
                        test    i2cdata,i2cmask    wz
              if_z      or      dira,i2csda                                   
              if_nz     andn    dira,i2csda
                        waitcnt i2ctime,i2cclkhigh                                   
                        test    i2cbootsclm,i2cscl wz                           
              if_nz     or      outa,i2cscl                                    
              if_nz     or      dira,i2cscl
              if_z      andn    dira,i2cscl                                    
                        waitcnt i2ctime,i2cclklow
                        andn    outa,i2cscl                                   
                        or      dira,i2cscl
                        ror     i2cmask,#1                                          
                        djnz    i2cbitcnt,#:i2cwritebit
                        andn    dira,i2csda                                      
                        waitcnt i2ctime,i2cclkhigh                                 
                        test    i2cbootsclm,i2cscl wz                           
              if_nz     or      outa,i2cscl                                    
              if_nz     or      dira,i2cscl
              if_z      andn    dira,i2cscl                                    
                        waitcnt i2ctime,#0                                          
                        test    i2csda,ina         wc                              
                        andn    outa,i2cscl                                    
                        or      dira,i2cscl
                        or      dira,i2csda                            
                        rol     i2cmask,#16                                          
i2cwrite_ret            ret
                                                                                  
                                                                                
                                                                                   
                                                                                    
i2cread                 mov     i2cbitcnt,#8
                        andn    dira,i2csda                                            
                        mov     i2ctime,i2cclklow
                        add     i2ctime,cnt                                       
:i2creadbit             waitcnt i2ctime,i2cclkhigh
                        test    i2cbootsclm,i2cscl wz                           
              if_nz     or      outa,i2cscl                                    
              if_nz     or      dira,i2cscl
              if_z      andn    dira,i2cscl                                    
                        waitcnt i2ctime,i2cclklow                                    
                        test    i2csda,ina         wz                             
                        andn    outa,i2cscl                                   
                        or      dira,i2cscl
              if_nz     or      i2cdata,i2cmask                               
              if_z      andn    i2cdata,i2cmask
                        ror     i2cmask,#1                                      
                        djnz    i2cbitcnt,#:i2creadbit                        
                        waitcnt i2ctime,i2cdataset                               
              if_c      andn    dira,i2csda                                          
              if_nc     or      dira,i2csda
                        waitcnt i2ctime,i2cclkhigh                                   
                        test    i2cbootsclm,i2cscl wz                           
              if_nz     or      outa,i2cscl                                    
              if_nz     or      dira,i2cscl
              if_z      andn    dira,i2cscl                                    
                        waitcnt i2ctime,#0                                           
                        andn    outa,i2cscl                                   
                        or      dira,i2cscl
                        or      dira,i2csda                            
                        rol     i2cmask,#16                                         
i2cread_ret             ret
                                                            
spientrypoint           test    i2ccmd,#iobootcmd  wc                   
              if_c      jmp     #spidoread                                 
                        cmp     i2ccmd,#iospistop wc,wz
              if_c      jmp     #spidoinit                                
              if_z      jmp     #spidostop
                        cmp     i2ccmd,#iospiwrite wc
              if_c      jmp     #spidoread
                        jmp     #spidowrite
                                                                        
                                                                           
                                                                             
spidoinit               movd    :moveit,#spimaskcs
                        mov     spiblkcnt,#4
:makemask               mov     i2cmask,#1
                        mov     i2ctemp,i2caddr                                   
                        and     i2ctemp,#%11111                                   
                        shl     i2cmask,i2ctemp
:moveit                 mov     0-0,i2cmask                                             
                        cmp     spiblkcnt,#1       wz
              if_ne     or      outa,i2cmask                                        
              if_ne     or      dira,i2cmask                                          
              if_e      andn    dira,i2cmask                                             
                        sub     :moveit,incrdst
                        ror     i2caddr,#6
                        djnz    spiblkcnt,#:makemask
                        rol     i2caddr,#24                                      
                        mov     i2ctime,cnt                                        
                        mov     spiblkcnt,spiinitcnt
:initread               call    #spirecvbyte                                           
                        djnz    spiblkcnt,#:initread                                   
                        mov     spiop,#0                                   
                        mov     spiparm,#0
                        call    #spisendcmd                                                
                        or      outa,spimaskcs                                         
:waitidle               mov     spiop,#55
                        call    #spisendcmd                                             
                        mov     spiop,#41
                        call    #spisendcmd                                            
                        or      outa,spimaskcs
                        cmp     i2cdata,#1         wz                                    
              if_e      jmp     #:waitidle
                        tjz     i2cdata,#i2cgoupdate                             
                        or      i2caddr,errorflag
                        jmp     #i2cgoupdate                                           
                                                                                   
                                                                               
spidostop               or      outa,spimaskcs                                 
                        call    #spirecvbyte                                  
                        call    #spirecvbyte                                   
                        andn    dira,spimaskdo
                        andn    dira,spimaskdi                                 
                        andn    dira,spimaskcs                                  
                        andn    dira,spimaskclk                                  
                        mov     spimaskdo,#0                                    
                        mov     spimaskdi,#0                                      
                        mov     spimaskcs,#0                                     
                        mov     spimaskclk,#0
                        jmp     #i2cgoupdate
                                                                           
                                                                           
                                                                               
                                                  
spidoread               mov     spiop,#17                                  
:readrepeat             mov     i2ctime,cnt                                    
                        mov     spiparm,i2caddr
                        call    #spisendcmd                                        
                        call    #spiresponse
                        mov     spiblkcnt,spiblksize                                
:getread                call    #spirecvbyte
                        tjz     i2ccount,#:skipstore                               
                        call    #storedata
                        sub     i2ccount,#1
:skipstore              djnz    spiblkcnt,#:getread                                  
                        call    #spirecvbyte
                        call    #spirecvbyte                                        
                        add     i2caddr,#1
                        or      outa,spimaskcs                                            
                        tjnz    i2ccount,#:readrepeat                                     
checkendio              test    i2ccmd,#iobootcmd  wc
                 if_nc  jmp     #i2cgoupdate                                        
                        test    i2caddr,errorflag  wc
                        and     checksum,#$ff      wz                                    
           if_z_and_nc  jmp     #nowbootspin                                        
                        or      i2caddr,errorflag
                        test    options,#nostore   wc
                 if_c   jmp     #i2cgoupdate                                            
stopthiscog             cogid   i2ccogid                                                   
                        cogstop i2ccogid                                
                      
                                                                            
                                                                              
                                                                          
                                      
spidowrite              mov     spiop,#24                            
                        mov     i2ctime,cnt                            
                        mov     spiparm,i2caddr
                        call    #spisendcmd                                       
                        mov     i2cdata,#$fe                                        
                        call    #spisendbyte
                        mov     spiblkcnt,spiblksize                                
:putwrite               mov     i2cdata,#0                                              
                        tjz     i2ccount,#:padwrite                                
                        rdbyte  i2cdata,i2cbufadr                                       
                        add     i2cbufadr,#1
                        sub     i2ccount,#1
:padwrite               call    #spisendbyte
                        djnz    spiblkcnt,#:putwrite                                 
                        call    #spirecvbyte
                        call    #spirecvbyte                                        
                        call    #spiresponse
                        and     i2cdata,#$1f                                       
                        cmp     i2cdata,#5         wz
              if_ne     or      i2caddr,errorflag                              
              if_ne     jmp     #i2cgoupdate
                        movs    spiwaitdata,#0                               
                        call    #spiwaitbusy
                        add     i2caddr,#1
                        or      outa,spimaskcs                                          
                        tjnz    i2ccount,#spidowrite                                   
                        jmp     #i2cgoupdate
                    
spisendcmd              andn    outa,spimaskcs                                            
                        call    #spirecvbyte                                          
                        mov     i2cdata,spiop
                        or      i2cdata,#$40                                                
                        call    #spisendbyte
                        mov     i2cdata,spiparm
                        shr     i2cdata,#15                                                
                        call    #spisendbyte 
                        mov     i2cdata,spiparm                                           
                        shr     i2cdata,#7                                          
                        call    #spisendbyte
                        mov     i2cdata,spiparm                                          
                        shl     i2cdata,#1                           
                        call    #spisendbyte
                        mov     i2cdata,#0
                        call    #spisendbyte
                        mov     i2cdata,#$95                                             
                        call    #spisendbyte
spiresponse             movs    spiwaitdata,#$ff                                     
spiwaitbusy             call    #spirecvbyte
                        mov     i2ctemp,cnt
                        sub     i2ctemp,i2ctime                                            
                        cmp     i2ctemp,saveclkfreq wc
              if_nc     or      i2caddr,errorflag
              if_nc     jmp     #i2cgoupdate
spiwaitdata             cmp     i2cdata,#0-0       wz                                 
              if_e      jmp     #spiwaitbusy                                  
spisendcmd_ret
spiresponse_ret
spiwaitbusy_ret         ret
                     
spisendbyte             mov     i2cmask,#%10000000
:sendbit                test    i2cmask,i2cdata    wc
                        andn    outa,spimaskclk                                    
                        muxc    outa,spimaskdi
                        or      outa,spimaskclk
                        shr     i2cmask,#1                                                 
                        tjnz    i2cmask,#:sendbit
                        or      outa,spimaskdi                                         
spisendbyte_ret         ret
spirecvbyte             mov     i2cmask,#%10000000
:recvbit                andn    outa,spimaskclk                                       
                        or      outa,spimaskclk                              
                        test    spimaskdo,ina      wc     
                        muxc    i2cdata,i2cmask
                        shr     i2cmask,#1                                                 
                        tjnz    i2cmask,#:recvbit
                        and     i2cdata,#%11111111                           
spirecvbyte_ret         ret
                                                                                
                                                                           
                                                                           
                                                                     
storedata               test    options,#ionostore wc
                if_nc   wrbyte  i2cdata,i2cbufadr                                         
                        add     i2cbufadr,#1                                        
                        add     checksum,i2cdata                                           
shiftdata               shl     i2cdata,#0-0
storelocal              or      preamble+0,i2cdata                                         
                        add     shiftdata,#8                                              
                        cmp     shiftdata,testins  wz                            
                if_z    movs    shiftdata,#0                                                 
                if_z    add     storelocal,incrdst
                if_z    cmp     storelocal,testdst wz                                  
                if_z    mov     storelocal,nostore
                if_z    test    i2ccmd,#iobootcmd  wc                                       
          if_c_and_z    mov     i2ccount,preamble+2                                         
          if_c_and_z    and     i2ccount,i2cwordmask                                        
          if_c_and_z    sub     i2ccount,#16 - 1                                            
storedata_ret           ret
                                                                              
                                                                                
                                                                                 
                                                                            
nowbootspin             test    options,#ionostore wc
                        mov     i2ctemp,preamble+2
                        shr     i2ctemp,#16                              
                        sub     i2ctemp,#4
                if_nc   wrlong  stackmark,i2ctemp                                    
                        sub     i2ctemp,#4
                if_nc   wrlong  stackmark,i2ctemp
                        mov     i2cother,preamble+2                      
                        and     i2cother,i2cwordmask
                        sub     i2ctemp,i2cother
                        shr     i2ctemp,#2         wz                                    
:zeroit  if_nz_and_nc   wrlong  i2czero,i2cother                                       
         if_nz_and_nc   add     i2cother,#4
         if_nz_and_nc   djnz    i2ctemp,#:zeroit                                  
                        mov     i2ctemp,preamble
                        cmp     i2ctemp,saveclkfreq wz                                    
                        mov     i2ctemp,preamble+1
                        and     i2ctemp,#$ff                                              
                if_ne   jmp     #:changeclock
                        cmp     i2ctemp,saveclkmode wz                                   
                if_e    jmp     #:juststartup
:changeclock            and     i2ctemp,#$f8                                             
                if_nc   clkset  i2ctemp                                                 
                        mov     i2ctemp,time_xtal
:startupdelay           djnz    i2ctemp,#:startupdelay                                           
                        mov     i2ctemp,preamble+1
                        and     i2ctemp,#$ff                                           
                if_nc   clkset  i2ctemp
:juststartup            mov     i2cother,i2ccmd                                               
                        and     i2cother,#%111                                             
                        test    options,#iostopldr  wz                                        
                if_nz   cogid   i2cother                                                    
                        or      i2cother,interpreter
                if_nc   coginit i2cother
                                                                                 
                                                                  
i2cgoupdate             and     i2cbufadr,i2cwordmask                             
                        shl     i2ccount,#16                                     
                        or      i2ccount,i2cbufadr
                        mov     i2ctemp,par
                        add     i2ctemp,#4
                        wrlong  i2ccount,i2ctemp
                        wrlong  i2caddr,par                                         
                        jmp     #i2centrypoint                                      
                                                                                            
                                                                                       
                                                                             
                                                                                        
                                                                                        
                                                                
                                     
                                                                               
                                                                                         
                                                           
                                                       
i2czero
actiontbl               long    %0000000000                                                
                        long    %0110101111,%0010010111                                        
                        long    %0111001110,%0010010110                                       
                        long    %0100000100,%0010010100                       
                             
i2cwordmask             long    $0000ffff
i2caddrmask             long    $00ffffff
errorflag               long    $80000000                                                
speedmask               long    $40000000                                                  
time_xtal               long    20 * 20000 / 4 / 1                                  
interpreter             long    ($0004 << 16) | ($f004 << 2) | %0000
i2cbootsclm             long    |<i2cbootscl                                         
spiblksize                                                                                   
incrdst                 long    %10_00000000                                                 
testins                 shl     i2cdata,#32                                                      
initstore               or      preamble+0,i2cdata                                              
testdst                 or      preamble+4,i2cdata                                               
nostore                 jmp     #storedata_ret                                                    
spiinitcnt              long    32768 / 8                                            
stackmark               long    $fff9ffff                                                        
                             
preamble                long    0, 0, 0, 0                                                
action                  long    0
i2cother
i2ccogid                long    0
i2ccmd                  long    0
firstcall               long    -1                                                           
i2ctemp                 long    0
i2ccount                long    0
i2cbufadr               long    0
i2caddr                 long    0
i2cdataset              long    0                                                        
i2cclklow               long    0                                                       
i2cclkhigh              long    0                                                        
i2cdataset1             long    0                                                               
i2cclklow1              long    0                                                              
i2cclkhigh1             long    0                                                               
i2cdataset4             long    0                                                               
i2cclklow4              long    0                                                              
i2cclkhigh4             long    0                                                               
i2cpause                long    0                                                                
saveclkfreq             long    0                                                             
saveclkmode             long    0                                                             
spiblkcnt               long    0                                                               
checksum                long    0                                                        
options                 long    0                                                            
                                             
spiop                                                                                   
i2cscl                  long    0                                         
spiparm                                                                                  
i2csda                  long    0                                         
i2ctime                 long    0                                             
i2cdata                 long    0                                                          
i2cmask                 long    0                                                       
i2cbitcnt               long    0                                                  
                                                    
spimaskdo               long    0
spimaskclk              long    0
spimaskdi               long    0
spimaskcs               long    0
                        fit
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     